﻿using Infragistics.Win.UltraWinLiveTileView;
using Infragistics.Win;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win.UltraWinLiveTileView.UIElements;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.Misc;

namespace WLTV_AddControlToTile
{
    class CustomCreationFilter : IUIElementCreationFilter
    {
        private LiveTile tile;
        private UltraGrid grid = null;
        private UltraPanel panel;
        public delegate void InitializeLayoutHandler(object sender, InitializeLayoutEventArgs e);
        public event InitializeLayoutHandler OnInitializeLayoutHandler;

        public CustomCreationFilter(LiveTile tile, UltraPanel panel)
        {
            this.tile = tile;
            this.panel = panel;
            grid = new UltraGrid();
        }

        public UltraGrid Grid
        {
            get
            {
                return grid;
            }
            set
            {
                grid = value;
            }
        }

        public LiveTile Tile
        {
            get
            {
                return tile;
            }
            set
            {
                tile = value;
            }
        }

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is TileUIElement && ((TileUIElement)parent).Tile == tile)
            {
                if (panel.ClientArea.Controls.Count == 0)
                {
                    panel.ClientArea.Controls.Add(grid);
                    
                    grid.Dock = System.Windows.Forms.DockStyle.Fill;
                    grid.InitializeLayout += grid_InitializeLayout;
                }
                panel.Location = parent.Rect.Location;
                panel.Size = parent.Rect.Size;
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        void grid_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            if (OnInitializeLayoutHandler != null)
            {
                OnInitializeLayoutHandler.Invoke(sender, e);
            }
        }
        
    }
}
